tigase.db.comp

## Class ConfigRepository<Item extends RepositoryItem>

- java.lang.Object
- - tigase.db.comp.ConfigRepository<Item>

- Type Parameters:
    `Item` -
  All Implemented Interfaces:
    Iterable<Item>, ComponentRepository<Item>, Repository
  Direct Known Subclasses:
    ClConConfigRepository, CompConfigRepository, UserRepoRepository

      public abstract class ConfigRepository<Item extends RepositoryItem>
      extends Object
      implements ComponentRepository<Item>

  Created: Oct 3, 2009 2:58:41 PM
  Version:
    $Rev$
  Author:
    Artur Hefczyc

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface tigase.db.Repository

      `Repository.Meta`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Map<String,Item>` | `items` Field description
    `protected int` | `itemsHash`

    - ### Fields inherited from interface tigase.db.comp.ComponentRepository

      `COMP_REPO_BIND`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ConfigRepository()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addItem(Item item)` The method adds a new or updates existing Item in the repository.
    `void` | `addItemNoStore(Item item)` The method adds a new or updates existing Item.
    `void` | `addRepoChangeListener(RepositoryChangeListenerIfc<Item> repoChangeListener)` Adds a listener for repository Item change.
    `Collection<Item>` | `allItems()` Returns a collection with all items stored in the repository.
    `boolean` | `contains(String key)` The method checks whether the item is stored in the repository.
    `abstract String` | `getConfigKey()` Method description
    `abstract String[]` | `getDefaultPropetyItems()` Method description
    `void` | `getDefaults(Map<String,Object> defs, Map<String,Object> params)` The method is called to obtain default configuration settings if there are any for this repository implementation The configuration settings are implementation dependent and there are no defaults set by the server.
    `Item` | `getItem(String key)` The method returns all item configuration parameters for a key or `null` if the item does not exist in the repository.
    `abstract String` | `getPropertyKey()` Method description
    `protected void` | `initItemsMap()` Method create instance of items Map.
    `boolean` | `itemChanged(Item oldItem, Item newItem)` Method description
    `Iterator<Item>` | `iterator()`
    `void` | `reload()` This method is called to reload items from the database or other permanent storage.
    `void` | `removeItem(String key)` The method is called to remove given Item from the memory cache and permanent storage.
    `void` | `removeRepoChangeListener(RepositoryChangeListenerIfc<Item> repoChangeListener)` Removes a listener for repository Item change.
    `void` | `setAutoloadTimer(long delay)` Sets autoload task to periodically reload data from database.
    `void` | `setProperties(Map<String,Object> properties)` The method is called to set configuration for this repository implementation.
    `int` | `size()` The method returns number of items in the repository.
    `void` | `store()` The method is called to store all data in the database.
    `String` | `toString()`
    `String` | `validateItem(Item item)` Performs Item validation to check whether it meets the repository policy.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tigase.db.comp.ComponentRepository

      `destroy, getItemInstance`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

    - ### Methods inherited from interface tigase.db.Repository

      `initRepository`

- - ### Field Detail

    - #### items

          protected Map<String,Item extends RepositoryItem> items

      Field description

    - #### itemsHash

          protected int itemsHash

  - ### Constructor Detail

    - #### ConfigRepository

          public ConfigRepository()

  - ### Method Detail

    - #### setAutoloadTimer

          public void setAutoloadTimer(long delay)

      Description copied from interface: `ComponentRepository`
      Sets autoload task to periodically reload data from database.
      Specified by:
        `setAutoloadTimer` in interface `ComponentRepository<Item extends RepositoryItem>`
      Parameters:
        `delay` - in seconds between each database reload.

    - #### addRepoChangeListener

          public void addRepoChangeListener(RepositoryChangeListenerIfc<Item> repoChangeListener)

      Description copied from interface: `ComponentRepository`
      Adds a listener for repository Item change.
      Specified by:
        `addRepoChangeListener` in interface `ComponentRepository<Item extends RepositoryItem>`

    - #### removeRepoChangeListener

          public void removeRepoChangeListener(RepositoryChangeListenerIfc<Item> repoChangeListener)

      Description copied from interface: `ComponentRepository`
      Removes a listener for repository Item change.
      Specified by:
        `removeRepoChangeListener` in interface `ComponentRepository<Item extends RepositoryItem>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getConfigKey

          public abstract String getConfigKey()

      Method description

    - #### getDefaultPropetyItems

          public abstract String[] getDefaultPropetyItems()

      Method description

    - #### getPropertyKey

          public abstract String getPropertyKey()

      Method description

    - #### addItem

          public void addItem(Item item)

      Description copied from interface: `ComponentRepository`
      The method adds a new or updates existing Item in the repository. It needs to have all fields set correctly. After this method call is finished a new added item must be available in the component repository. The method adds the item to memory cache and permanent storage.
      Specified by:
        `addItem` in interface `ComponentRepository<Item extends RepositoryItem>`
      Parameters:
        `item` - a `Item` with all it's configuration parameters.

    - #### addItemNoStore

          public void addItemNoStore(Item item)

      Description copied from interface: `ComponentRepository`
      The method adds a new or updates existing Item. It needs to have all fields set correctly. After this method call is finished a new added item must be available in the component repository. The method adds the item to memory cache but not to a permanent storage.
      Specified by:
        `addItemNoStore` in interface `ComponentRepository<Item extends RepositoryItem>`
      Parameters:
        `item` - a `Item` with all it's configuration parameters.

    - #### initItemsMap

          protected void initItemsMap()

      Method create instance of items Map. By overriding it it's possible to change implementation and it's settings.

    - #### itemChanged

          public boolean itemChanged(Item oldItem,
                                     Item newItem)

      Method description
      Parameters:
        `oldItem` -
        `newItem` -

    - #### allItems

          public Collection<Item> allItems()

      Description copied from interface: `ComponentRepository`
      Returns a collection with all items stored in the repository.
      Specified by:
        `allItems` in interface `ComponentRepository<Item extends RepositoryItem>`

    - #### contains

          public boolean contains(String key)

      Description copied from interface: `ComponentRepository`
      The method checks whether the item is stored in the repository.
      Specified by:
        `contains` in interface `ComponentRepository<Item extends RepositoryItem>`
      Parameters:
        `key` - a `String` with key to search for.
      Returns:
        a `boolean` value `true` if the item exists in the repository or `false` of it does not.

    - #### getDefaults

          public void getDefaults(Map<String,Object> defs,
                                  Map<String,Object> params)

      Description copied from interface: `ComponentRepository`
      The method is called to obtain default configuration settings if there are any for this repository implementation The configuration settings are implementation dependent and there are no defaults set by the server. Default settings returned by this method are then saved in the configuration file and presented to the admin for further adjustments.
      Specified by:
        `getDefaults` in interface `ComponentRepository<Item extends RepositoryItem>`
      Parameters:
        `defs` - is a `Map` collection where all repository configuration defaults must be put.
        `params` - is a `Map` collection with some preset properties for the server. These settings can be used to adjust repository defaults, for example they can contain database connection URL or initial list of virtual domains.

    - #### getItem

          public Item getItem(String key)

      Description copied from interface: `ComponentRepository`
      The method returns all item configuration parameters for a key or `null` if the item does not exist in the repository.
      Specified by:
        `getItem` in interface `ComponentRepository<Item extends RepositoryItem>`
      Parameters:
        `key` - a `String` with item identifier to search for.
      Returns:
        a `Item` for a given key or `null` if the item is not in the repository.

    - #### iterator

          public Iterator<Item> iterator()

      Specified by:
        `iterator` in interface `Iterable<Item extends RepositoryItem>`

    - #### reload

          public void reload()

      Description copied from interface: `ComponentRepository`
      This method is called to reload items from the database or other permanent storage. It is possible that items list is modified externally by third-party system. When all modifications are done this method is called to refresh the class cache. Whether the implementation load whole list or just last modifications is implementation dependent.
      Specified by:
        `reload` in interface `ComponentRepository<Item extends RepositoryItem>`

    - #### removeItem

          public void removeItem(String key)

      Description copied from interface: `ComponentRepository`
      The method is called to remove given Item from the memory cache and permanent storage. After this method is completed the item should no longer be available in the component repository.
      Specified by:
        `removeItem` in interface `ComponentRepository<Item extends RepositoryItem>`
      Parameters:
        `key` - a `String` with domain name to remove.

    - #### setProperties

          public void setProperties(Map<String,Object> properties)

      Description copied from interface: `ComponentRepository`
      The method is called to set configuration for this repository implementation. The configuration is repository implementation dependent. There are no default settings for the repository.
      Specified by:
        `setProperties` in interface `ComponentRepository<Item extends RepositoryItem>`
      Parameters:
        `properties` - a `Map` with configuration settings. Content of this `Map` must not be modified. This read-only collection.

    - #### size

          public int size()

      Description copied from interface: `ComponentRepository`
      The method returns number of items in the repository.
      Specified by:
        `size` in interface `ComponentRepository<Item extends RepositoryItem>`
      Returns:
        an `int` value with number of items in the repository.

    - #### store

          public void store()

      Description copied from interface: `ComponentRepository`
      The method is called to store all data in the database. It is used when the repository has been changed in some way and the changes have to be put to a permanent storage for later retrieval.
      Specified by:
        `store` in interface `ComponentRepository<Item extends RepositoryItem>`

    - #### validateItem

          public String validateItem(Item item)

      Description copied from interface: `ComponentRepository`
      Performs Item validation to check whether it meets the repository policy. If validation is successful the method returns `null`, otherwise it returns an error description.
      Specified by:
        `validateItem` in interface `ComponentRepository<Item extends RepositoryItem>`
      Parameters:
        `item` - is an `Item` object to perform validation checking upon.
      Returns:
        `null` on success and an error message otherwise.

Copyright © 2017 "Tigase, Inc.". All rights reserved.